Index: uspace/drv/usbkbd/main.c
===================================================================
--- uspace/drv/usbkbd/main.c	(revision 84439d7c2ebefbea307e636b8e8316fb8f84e090)
+++ uspace/drv/usbkbd/main.c	(revision 75732daeac84e2935c03d316ed5cb327455ac6a3)
@@ -28,75 +28,264 @@
 #include <usb/usbdrv.h>
 #include <driver.h>
+#include <ipc/driver.h>
 #include <errno.h>
+#include <fibril.h>
+#include <usb/classes/hid.h>
+#include <usb/classes/hidparser.h>
+#include <usb/devreq.h>
+#include <usb/descriptor.h>
 
 #define BUFFER_SIZE 32
-
-/* Call this periodically to check keyboard status changes. */
-static void poll_keyboard(device_t *dev)
+#define NAME "usbkbd"
+
+#define GUESSED_POLL_ENDPOINT 1
+
+/*
+ * Callbacks for parser
+ */
+static void usbkbd_process_keycodes(const uint16_t *key_codes, size_t count,
+                                    void *arg)
+{
+
+}
+
+/*
+ * Kbd functions
+ */
+static int usbkbd_parse_descriptors(usb_hid_dev_kbd_t *kbd_dev,
+                                    const uint8_t *data, size_t size)
+{
+//	const uint8_t *pos = data;
+	
+//	// get the configuration descriptor (should be first)
+//	if (*pos != sizeof(usb_standard_configuration_descriptor_t)
+//	    || *(pos + 1) != USB_DESCTYPE_CONFIGURATION) {
+//		fprintf(stderr, "Wrong format of configuration descriptor");
+//		return EINVAL;
+//	}
+	
+//	usb_standard_configuration_descriptor_t config_descriptor;
+//	memcpy(&config_descriptor, pos, 
+//	    sizeof(usb_standard_configuration_descriptor_t));
+//	pos += sizeof(usb_standard_configuration_descriptor_t);
+	
+//	// parse other descriptors
+//	while (pos - data < size) {
+//		//uint8_t desc_size = *pos;
+//		uint8_t desc_type = *(pos + 1);
+//		switch (desc_type) {
+//		case USB_DESCTYPE_INTERFACE:
+//			break;
+//		case USB_DESCTYPE_ENDPOINT:
+//			break;
+//		case USB_DESCTYPE_HID:
+//			break;
+//		case USB_DESCTYPE_HID_REPORT:
+//			break;
+//		case USB_DESCTYPE_HID_PHYSICAL:
+//			break;
+//		}
+//	}
+	
+	return EOK;
+}
+
+static int usbkbd_get_descriptors(usb_hid_dev_kbd_t *kbd_dev)
+{
+	// get the first configuration descriptor (TODO: or some other??)
+	usb_standard_configuration_descriptor_t config_desc;
+	
+	int rc = usb_drv_req_get_bare_configuration_descriptor(
+	    kbd_dev->device->parent_phone, kbd_dev->address, 0, &config_desc);
+	
+	if (rc != EOK) {
+		return rc;
+	}
+	
+	// prepare space for all underlying descriptors
+	uint8_t *descriptors = (uint8_t *)malloc(config_desc.total_length);
+	if (descriptors == NULL) {
+		return ENOMEM;
+	}
+	
+	size_t transferred = 0;
+	// get full configuration descriptor
+	rc = usb_drv_req_get_full_configuration_descriptor(
+	    kbd_dev->device->parent_phone, kbd_dev->address, 0, descriptors,
+	    config_desc.total_length, &transferred);
+	
+	if (rc != EOK) {
+		return rc;
+	}
+	if (transferred != config_desc.total_length) {
+		return ELIMIT;
+	}
+	
+	rc = usbkbd_parse_descriptors(kbd_dev, descriptors, transferred);
+	free(descriptors);
+	
+	return rc;
+}
+
+static usb_hid_dev_kbd_t *usbkbd_init_device(device_t *dev)
+{
+	usb_hid_dev_kbd_t *kbd_dev = (usb_hid_dev_kbd_t *)malloc(
+			sizeof(usb_hid_dev_kbd_t));
+
+	if (kbd_dev == NULL) {
+		fprintf(stderr, NAME ": No memory!\n");
+		return NULL;
+	}
+
+	kbd_dev->device = dev;
+
+	// get phone to my HC and save it as my parent's phone
+	// TODO: maybe not a good idea if DDF will use parent_phone
+	kbd_dev->device->parent_phone = usb_drv_hc_connect(dev, 0);
+
+	kbd_dev->address = usb_drv_get_my_address(dev->parent_phone,
+	    dev);
+
+	// doesn't matter now that we have no address
+//	if (kbd_dev->address < 0) {
+//		fprintf(stderr, NAME ": No device address!\n");
+//		free(kbd_dev);
+//		return NULL;
+//	}
+
+	// default endpoint
+	kbd_dev->poll_endpoint = GUESSED_POLL_ENDPOINT;
+	
+	/*
+	 * will need all descriptors:
+	 * 1) choose one configuration from configuration descriptors 
+	 *    (set it to the device)
+	 * 2) set endpoints from endpoint descriptors
+	 */
+
+	// TODO: get descriptors
+	usbkbd_get_descriptors(kbd_dev);
+	// TODO: parse descriptors and save endpoints
+
+	return kbd_dev;
+}
+
+static void usbkbd_process_interrupt_in(usb_hid_dev_kbd_t *kbd_dev,
+                                        uint8_t *buffer, size_t actual_size)
+{
+	/*
+	 * here, the parser will be called, probably with some callbacks
+	 * now only take last 6 bytes and process, i.e. send to kbd
+	 */
+
+	usb_hid_report_in_callbacks_t *callbacks =
+	    (usb_hid_report_in_callbacks_t *)malloc(
+		sizeof(usb_hid_report_in_callbacks_t));
+	callbacks->keyboard = usbkbd_process_keycodes;
+
+	usb_hid_parse_report(kbd_dev->parser, buffer, actual_size, callbacks, 
+	    NULL);
+}
+
+static void usbkbd_poll_keyboard(usb_hid_dev_kbd_t *kbd_dev)
 {
 	int rc;
 	usb_handle_t handle;
-	char buffer[BUFFER_SIZE];
+	uint8_t buffer[BUFFER_SIZE];
 	size_t actual_size;
-	usb_endpoint_t poll_endpoint = 1;
-
-	usb_address_t my_address = usb_drv_get_my_address(dev->parent_phone,
-	    dev);
-	if (my_address < 0) {
-		return;
-	}
+	//usb_endpoint_t poll_endpoint = 1;
+
+//	usb_address_t my_address = usb_drv_get_my_address(dev->parent_phone,
+//	    dev);
+//	if (my_address < 0) {
+//		return;
+//	}
 
 	usb_target_t poll_target = {
-		.address = my_address,
-		.endpoint = poll_endpoint
+		.address = kbd_dev->address,
+		.endpoint = kbd_dev->poll_endpoint
 	};
 
-	rc = usb_drv_async_interrupt_in(dev->parent_phone, poll_target,
-	    buffer, BUFFER_SIZE, &actual_size, &handle);
-	if (rc != EOK) {
-		return;
-	}
-
-	rc = usb_drv_async_wait_for(handle);
-	if (rc != EOK) {
-		return;
-	}
-
-	/*
-	 * If the keyboard answered with NAK, it returned no data.
-	 * This implies that no change happened since last query.
-	 */
-	if (actual_size == 0) {
-		return;
-	}
-
-	/*
-	 * Process pressed keys.
-	 */
-}
-
-static int add_kbd_device(device_t *dev)
+	while (true) {
+		async_usleep(1000 * 1000);
+		rc = usb_drv_async_interrupt_in(kbd_dev->device->parent_phone,
+		    poll_target, buffer, BUFFER_SIZE, &actual_size, &handle);
+
+		if (rc != EOK) {
+			continue;
+		}
+
+		rc = usb_drv_async_wait_for(handle);
+		if (rc != EOK) {
+			continue;
+		}
+
+		/*
+		 * If the keyboard answered with NAK, it returned no data.
+		 * This implies that no change happened since last query.
+		 */
+		if (actual_size == 0) {
+			continue;
+		}
+
+		/*
+		 * TODO: Process pressed keys.
+		 */
+		usbkbd_process_interrupt_in(kbd_dev, buffer, actual_size);
+	}
+
+	// not reached
+	assert(0);
+}
+
+static int usbkbd_fibril_device(void *arg)
+{
+	printf("!!! USB device fibril\n");
+
+	if (arg == NULL) {
+		printf("No device!\n");
+		return -1;
+	}
+
+	device_t *dev = (device_t *)arg;
+
+	// initialize device (get and process descriptors, get address, etc.)
+	usb_hid_dev_kbd_t *kbd_dev = usbkbd_init_device(dev);
+
+	usbkbd_poll_keyboard(kbd_dev);
+
+	return EOK;
+}
+
+static int usbkbd_add_device(device_t *dev)
 {
 	/* For now, fail immediately. */
-	return ENOTSUP;
+	//return ENOTSUP;
 
 	/*
 	 * When everything is okay, connect to "our" HC.
-	 */
-	int phone = usb_drv_hc_connect(dev, 0);
-	if (phone < 0) {
-		/*
-		 * Connecting to HC failed, roll-back and announce
-		 * failure.
-		 */
-		return phone;
-	}
-
-	dev->parent_phone = phone;
-
-	/*
-	 * Just for fun ;-).
-	 */
-	poll_keyboard(dev);
+	 *
+	 * Not supported yet, skip..
+	 */
+//	int phone = usb_drv_hc_connect(dev, 0);
+//	if (phone < 0) {
+//		/*
+//		 * Connecting to HC failed, roll-back and announce
+//		 * failure.
+//		 */
+//		return phone;
+//	}
+
+//	dev->parent_phone = phone;
+
+	/*
+	 * Create new fibril for handling this keyboard
+	 */
+	fid_t fid = fibril_create(usbkbd_fibril_device, dev);
+	if (fid == 0) {
+		printf("%s: failed to start fibril for HID device\n", NAME);
+		return ENOMEM;
+	}
+	fibril_add_ready(fid);
 
 	/*
@@ -107,9 +296,9 @@
 
 static driver_ops_t kbd_driver_ops = {
-	.add_device = add_kbd_device,
+	.add_device = usbkbd_add_device,
 };
 
 static driver_t kbd_driver = {
-	.name = "usbkbd",
+	.name = NAME,
 	.driver_ops = &kbd_driver_ops
 };
Index: uspace/drv/usbkbd/usbkbd.ma
===================================================================
--- uspace/drv/usbkbd/usbkbd.ma	(revision 84439d7c2ebefbea307e636b8e8316fb8f84e090)
+++ uspace/drv/usbkbd/usbkbd.ma	(revision 75732daeac84e2935c03d316ed5cb327455ac6a3)
@@ -1,2 +1,4 @@
 10 usb&class=hid
+10 usb&class=HID
+10 usb&interface&class=HID
 10 usb&hid
Index: uspace/drv/vhc/Makefile
===================================================================
--- uspace/drv/vhc/Makefile	(revision 84439d7c2ebefbea307e636b8e8316fb8f84e090)
+++ uspace/drv/vhc/Makefile	(revision 75732daeac84e2935c03d316ed5cb327455ac6a3)
@@ -39,5 +39,4 @@
 
 SOURCES = \
-	addrmgm.c \
 	conndev.c \
 	connhost.c \
Index: uspace/drv/vhc/conn.h
===================================================================
--- uspace/drv/vhc/conn.h	(revision 84439d7c2ebefbea307e636b8e8316fb8f84e090)
+++ uspace/drv/vhc/conn.h	(revision 75732daeac84e2935c03d316ed5cb327455ac6a3)
@@ -48,11 +48,5 @@
 
 void address_init(void);
-int reserve_default_address(device_t *);
-int release_default_address(device_t *);
-int request_address(device_t *, usb_address_t *);
-int release_address(device_t *, usb_address_t);
-int bind_address(device_t *, usb_address_t, devman_handle_t);
 
-int tell_address(device_t *, devman_handle_t, usb_address_t *);
 
 void default_connection_handler(device_t *, ipc_callid_t, ipc_call_t *);
Index: uspace/drv/vhc/connhost.c
===================================================================
--- uspace/drv/vhc/connhost.c	(revision 84439d7c2ebefbea307e636b8e8316fb8f84e090)
+++ uspace/drv/vhc/connhost.c	(revision 75732daeac84e2935c03d316ed5cb327455ac6a3)
@@ -36,4 +36,5 @@
 #include <errno.h>
 #include <usb/usb.h>
+#include <usb/hcd.h>
 
 #include "vhcd.h"
@@ -57,5 +58,5 @@
 		case USB_DIRECTION_IN:
 			transfer->in_callback(transfer->dev,
-			    size, outcome,
+			    outcome, size,
 			    transfer->arg);
 			break;
@@ -92,5 +93,5 @@
     usbhc_iface_transfer_out_callback_t callback, void *arg)
 {
-	printf(NAME ": transfer OUT [%d.%d (%s); %u]\n",
+	dprintf(3, "transfer OUT [%d.%d (%s); %zu]",
 	    target.address, target.endpoint,
 	    usb_str_transfer_type(transfer_type),
@@ -112,5 +113,5 @@
     usbhc_iface_transfer_out_callback_t callback, void *arg)
 {
-	printf(NAME ": transfer SETUP [%d.%d (%s); %u]\n",
+	dprintf(3, "transfer SETUP [%d.%d (%s); %zu]",
 	    target.address, target.endpoint,
 	    usb_str_transfer_type(transfer_type),
@@ -132,5 +133,5 @@
     usbhc_iface_transfer_in_callback_t callback, void *arg)
 {
-	printf(NAME ": transfer IN [%d.%d (%s); %u]\n",
+	dprintf(3, "transfer IN [%d.%d (%s); %zu]",
 	    target.address, target.endpoint,
 	    usb_str_transfer_type(transfer_type),
@@ -218,4 +219,58 @@
 }
 
+static usb_address_keeping_t addresses;
+
+
+static int reserve_default_address(device_t *dev)
+{
+	usb_address_keeping_reserve_default(&addresses);
+	return EOK;
+}
+
+static int release_default_address(device_t *dev)
+{
+	usb_address_keeping_release_default(&addresses);
+	return EOK;
+}
+
+static int request_address(device_t *dev, usb_address_t *address)
+{
+	usb_address_t addr = usb_address_keeping_request(&addresses);
+	if (addr < 0) {
+		return (int)addr;
+	}
+
+	*address = addr;
+	return EOK;
+}
+
+static int release_address(device_t *dev, usb_address_t address)
+{
+	return usb_address_keeping_release(&addresses, address);
+}
+
+static int bind_address(device_t *dev, usb_address_t address,
+    devman_handle_t handle)
+{
+	usb_address_keeping_devman_bind(&addresses, address, handle);
+	return EOK;
+}
+
+static int tell_address(device_t *dev, devman_handle_t handle,
+    usb_address_t *address)
+{
+	usb_address_t addr = usb_address_keeping_find(&addresses, handle);
+	if (addr < 0) {
+		return addr;
+	}
+
+	*address = addr;
+	return EOK;
+}
+
+void address_init(void)
+{
+	usb_address_keeping_init(&addresses, 50);
+}
 
 usbhc_iface_t vhc_iface = {
Index: uspace/drv/vhc/debug.c
===================================================================
--- uspace/drv/vhc/debug.c	(revision 84439d7c2ebefbea307e636b8e8316fb8f84e090)
+++ uspace/drv/vhc/debug.c	(revision 75732daeac84e2935c03d316ed5cb327455ac6a3)
@@ -35,31 +35,8 @@
 #include <stdio.h>
 #include <ipc/ipc.h>
+#include <usb/debug.h>
 
 #include "vhcd.h"
 
-/** Current debug level. */
-int debug_level = 0;
-
-/** Debugging printf.
- * This function is intended for single-line messages as it
- * automatically prints debugging prefix at the beginning of the
- * line.
- *
- * @see printf
- * @param level Debugging level.
- */
-void dprintf(int level, const char *format, ...)
-{
-	if (level > debug_level) {
-		return;
-	}
-	
-	printf("%s(%d): ", NAME, level);
-	va_list args;
-	va_start(args, format);
-	vprintf(format, args);
-	va_end(args);
-	printf("\n");
-}
 
 /** Debug print informing of invalid call.
Index: uspace/drv/vhc/devices.c
===================================================================
--- uspace/drv/vhc/devices.c	(revision 84439d7c2ebefbea307e636b8e8316fb8f84e090)
+++ uspace/drv/vhc/devices.c	(revision 75732daeac84e2935c03d316ed5cb327455ac6a3)
@@ -147,5 +147,5 @@
 	if (virthub_dev.address == transaction->target.address) {
 		size_t tmp;
-		dprintf(3, "sending `%s' transaction to hub",
+		dprintf(1, "sending `%s' transaction to hub",
 		    usbvirt_str_transaction_type(transaction->type));
 		switch (transaction->type) {
Index: uspace/drv/vhc/hc.c
===================================================================
--- uspace/drv/vhc/hc.c	(revision 84439d7c2ebefbea307e636b8e8316fb8f84e090)
+++ uspace/drv/vhc/hc.c	(revision 75732daeac84e2935c03d316ed5cb327455ac6a3)
@@ -50,7 +50,7 @@
 #include "hub.h"
 
-#define USLEEP_BASE (500 * 1000)
+#define USLEEP_BASE (0 * 5 * 1000)
 
-#define USLEEP_VAR 5000
+#define USLEEP_VAR 50
 
 #define SHORTENING_VAR 15
@@ -89,5 +89,5 @@
     usb_transaction_outcome_t outcome)
 {
-	dprintf(3, "processing transaction " TRANSACTION_FORMAT ", outcome: %s",
+	dprintf(3, "transaction " TRANSACTION_FORMAT " done, outcome: %s",
 	    TRANSACTION_PRINTF(*transaction),
 	    usb_str_transaction_outcome(outcome));
@@ -116,5 +116,5 @@
 		char ports[HUB_PORT_COUNT + 2];
 		hub_get_port_statuses(ports, HUB_PORT_COUNT + 1);
-		dprintf(3, "virtual hub: addr=%d ports=%s",
+		dprintf(4, "virtual hub: addr=%d ports=%s",
 		    virthub_dev.address, ports);
 		
@@ -124,4 +124,8 @@
 		list_remove(first_transaction_link);
 		
+
+		dprintf(0, "about to process " TRANSACTION_FORMAT " (vhub:%s)",
+		    TRANSACTION_PRINTF(*transaction), ports);
+
 		dprintf(3, "processing transaction " TRANSACTION_FORMAT "",
 		    TRANSACTION_PRINTF(*transaction));
@@ -153,5 +157,5 @@
 	transaction->callback_arg = arg;
 	
-	dprintf(1, "creating transaction " TRANSACTION_FORMAT,
+	dprintf(3, "creating transaction " TRANSACTION_FORMAT,
 	    TRANSACTION_PRINTF(*transaction));
 	
Index: uspace/drv/vhc/hcd.c
===================================================================
--- uspace/drv/vhc/hcd.c	(revision 84439d7c2ebefbea307e636b8e8316fb8f84e090)
+++ uspace/drv/vhc/hcd.c	(revision 75732daeac84e2935c03d316ed5cb327455ac6a3)
@@ -79,6 +79,5 @@
 	 * Initialize our hub and announce its presence.
 	 */
-	hub_init();
-	usb_hcd_add_root_hub(dev);
+	hub_init(dev);
 
 	printf("%s: virtual USB host controller ready.\n", NAME);
@@ -111,5 +110,5 @@
 	printf("%s: virtual USB host controller driver.\n", NAME);
 
-	debug_level = 10;
+	usb_dprintf_enable(NAME, 0);
 
 	fid_t fid = fibril_create(hc_manager_fibril, NULL);
Index: uspace/drv/vhc/hub.c
===================================================================
--- uspace/drv/vhc/hub.c	(revision 84439d7c2ebefbea307e636b8e8316fb8f84e090)
+++ uspace/drv/vhc/hub.c	(revision 75732daeac84e2935c03d316ed5cb327455ac6a3)
@@ -37,9 +37,12 @@
 #include <usbvirt/device.h>
 #include <errno.h>
+#include <str_error.h>
 #include <stdlib.h>
+#include <driver.h>
 
 #include "vhcd.h"
 #include "hub.h"
 #include "hubintern.h"
+#include "conn.h"
 
 
@@ -141,5 +144,5 @@
 	.ops = &hub_ops,
 	.descriptors = &descriptors,
-	.lib_debug_level = 4,
+	.lib_debug_level = 0,
 	.lib_debug_enabled_tags = USBVIRT_DEBUGTAG_ALL
 };
@@ -148,14 +151,39 @@
 hub_device_t hub_dev;
 
+static usb_address_t hub_set_address(usbvirt_device_t *hub)
+{
+	usb_address_t new_address;
+	int rc = vhc_iface.request_address(NULL, &new_address);
+	if (rc != EOK) {
+		return rc;
+	}
+	
+	usb_device_request_setup_packet_t setup_packet = {
+		.request_type = 0,
+		.request = USB_DEVREQ_SET_ADDRESS,
+		.index = 0,
+		.length = 0,
+	};
+	setup_packet.value = new_address;
+
+	hub->transaction_setup(hub, 0, &setup_packet, sizeof(setup_packet));
+	hub->transaction_in(hub, 0, NULL, 0, NULL);
+	
+	return new_address;
+}
+
 /** Initialize virtual hub. */
-void hub_init(void)
-{
-	size_t i;
+void hub_init(device_t *hc_dev)
+{
+	size_t i;
+	
 	for (i = 0; i < HUB_PORT_COUNT; i++) {
 		hub_port_t *port = &hub_dev.ports[i];
 		
+		port->index = (int) i + 1;
 		port->device = NULL;
 		port->state = HUB_PORT_STATE_NOT_CONFIGURED;
 		port->status_change = 0;
+		fibril_mutex_initialize(&port->guard);
 	}
 	
@@ -163,4 +191,27 @@
 	
 	dprintf(1, "virtual hub (%d ports) created", HUB_PORT_COUNT);
+
+	usb_address_t hub_address = hub_set_address(&virthub_dev);
+	if (hub_address < 0) {
+		dprintf(1, "problem changing hub address (%s)",
+		    str_error(hub_address));
+	}
+
+	dprintf(2, "virtual hub address changed to %d", hub_address);
+
+	char *id;
+	int rc = asprintf(&id, "usb&hub");
+	if (rc <= 0) {
+		return;
+	}
+	devman_handle_t hub_handle;
+	rc = child_device_register_wrapper(hc_dev, "hub", id, 10, &hub_handle);
+	if (rc != EOK) {
+		free(id);
+	}
+
+	vhc_iface.bind_address(NULL, hub_address, hub_handle);	
+
+	dprintf(2, "virtual hub has devman handle %d", (int) hub_handle);
 }
 
@@ -175,6 +226,8 @@
 	for (i = 0; i < HUB_PORT_COUNT; i++) {
 		hub_port_t *port = &hub_dev.ports[i];
+		fibril_mutex_lock(&port->guard);
 		
 		if (port->device != NULL) {
+			fibril_mutex_unlock(&port->guard);
 			continue;
 		}
@@ -191,7 +244,9 @@
 		//if (port->state == HUB_PORT_STATE_DISCONNECTED) {
 			port->state = HUB_PORT_STATE_DISABLED;
-			set_port_status_change(port, HUB_STATUS_C_PORT_CONNECTION);
+			set_port_status_change_nl(port, HUB_STATUS_C_PORT_CONNECTION);
 		//}
 		
+		fibril_mutex_unlock(&port->guard);
+
 		return i;
 	}
Index: uspace/drv/vhc/hub.h
===================================================================
--- uspace/drv/vhc/hub.h	(revision 84439d7c2ebefbea307e636b8e8316fb8f84e090)
+++ uspace/drv/vhc/hub.h	(revision 75732daeac84e2935c03d316ed5cb327455ac6a3)
@@ -37,8 +37,9 @@
 
 #include <usbvirt/device.h>
+#include <driver.h>
 
 #include "devices.h"
 
-#define HUB_PORT_COUNT 6
+#define HUB_PORT_COUNT 2
 
 #define BITS2BYTES(bits) \
@@ -47,5 +48,5 @@
 extern usbvirt_device_t virthub_dev;
 
-void hub_init(void);
+void hub_init(device_t *);
 size_t hub_add_device(virtdev_connection_t *);
 void hub_remove_device(virtdev_connection_t *);
Index: uspace/drv/vhc/hubintern.h
===================================================================
--- uspace/drv/vhc/hubintern.h	(revision 84439d7c2ebefbea307e636b8e8316fb8f84e090)
+++ uspace/drv/vhc/hubintern.h	(revision 75732daeac84e2935c03d316ed5cb327455ac6a3)
@@ -37,4 +37,5 @@
 
 #include "hub.h"
+#include <fibril_synch.h>
 
 /** Endpoint number for status change pipe. */
@@ -121,6 +122,8 @@
 typedef struct {
 	virtdev_connection_t *device;
+	int index;
 	hub_port_state_t state;
 	uint16_t status_change;
+	fibril_mutex_t guard;
 } hub_port_t;
 
@@ -138,4 +141,5 @@
 void clear_port_status_change(hub_port_t *, uint16_t);
 void set_port_status_change(hub_port_t *, uint16_t);
+void set_port_status_change_nl(hub_port_t *, uint16_t);
 
 
Index: uspace/drv/vhc/hubops.c
===================================================================
--- uspace/drv/vhc/hubops.c	(revision 84439d7c2ebefbea307e636b8e8316fb8f84e090)
+++ uspace/drv/vhc/hubops.c	(revision 75732daeac84e2935c03d316ed5cb327455ac6a3)
@@ -59,4 +59,6 @@
 static int on_get_descriptor(struct usbvirt_device *dev,
     usb_device_request_setup_packet_t *request, uint8_t *data);
+static int on_set_configuration(struct usbvirt_device *dev,
+    usb_device_request_setup_packet_t *request, uint8_t *data);
 static int on_class_request(struct usbvirt_device *dev,
     usb_device_request_setup_packet_t *request, uint8_t *data);
@@ -64,8 +66,12 @@
     usb_endpoint_t endpoint,
     void *buffer, size_t size, size_t *actual_size);
+static void set_port_state(hub_port_t *, hub_port_state_t);
+static void clear_port_status_change_nl(hub_port_t *, uint16_t);
+static void set_port_state_nl(hub_port_t *, hub_port_state_t);
 
 /** Hub operations. */
 usbvirt_device_ops_t hub_ops = {
 	.on_standard_request[USB_DEVREQ_GET_DESCRIPTOR] = on_get_descriptor,
+	.on_standard_request[USB_DEVREQ_SET_CONFIGURATION] = on_set_configuration,
 	.on_class_device_request = on_class_request,
 	.on_data = NULL,
@@ -87,27 +93,100 @@
 }
 
+/** Callback for SET_CONFIGURATION request. */
+int on_set_configuration(struct usbvirt_device *dev,
+    usb_device_request_setup_packet_t *request, uint8_t *data)
+{
+	/* We must suspend power source to all ports. */
+	size_t i;
+	for (i = 0; i < HUB_PORT_COUNT; i++) {
+		hub_port_t *port = &hub_dev.ports[i];
+		
+		set_port_state(port, HUB_PORT_STATE_POWERED_OFF);
+	}
+	
+	/* Let the framework handle the rest of the job. */
+	return EFORWARD;
+}
+
+struct delay_port_state_change {
+	suseconds_t delay;
+	hub_port_state_t old_state;
+	hub_port_state_t new_state;
+	hub_port_t *port;
+};
+
+static int set_port_state_delayed_fibril(void *arg)
+{
+	struct delay_port_state_change *change
+	    = (struct delay_port_state_change *) arg;
+	
+	async_usleep(change->delay);
+	
+	fibril_mutex_lock(&change->port->guard);
+	if (change->port->state == change->old_state) {
+		set_port_state_nl(change->port, change->new_state);
+	}
+	fibril_mutex_unlock(&change->port->guard);
+	
+	free(change);
+	
+	return EOK;
+}
+
+static void set_port_state_delayed(hub_port_t *port,
+    suseconds_t delay_time,
+    hub_port_state_t old_state, hub_port_state_t new_state)
+{
+	struct delay_port_state_change *change
+	    = malloc(sizeof(struct delay_port_state_change));
+	change->port = port;
+	change->delay = delay_time;
+	change->old_state = old_state;
+	change->new_state = new_state;
+	fid_t fibril = fibril_create(set_port_state_delayed_fibril, change);
+	if (fibril == 0) {
+		printf("Failed to create fibril\n");
+		return;
+	}
+	fibril_add_ready(fibril);
+}
+
 /** Change port status and updates status change status fields.
  */
-static void set_port_state(hub_port_t *port, hub_port_state_t state)
-{
+void set_port_state(hub_port_t *port, hub_port_state_t state)
+{
+	fibril_mutex_lock(&port->guard);
+	set_port_state_nl(port, state);
+	fibril_mutex_unlock(&port->guard);
+}
+
+void set_port_state_nl(hub_port_t *port, hub_port_state_t state)
+{
+
+	dprintf(2, "setting port %d state to %d (%c) from %c (change=%u)",
+	    port->index,
+	    state, hub_port_state_as_char(state),
+	    hub_port_state_as_char(port->state),
+	    (unsigned int) port->status_change);
+	
+	if (state == HUB_PORT_STATE_POWERED_OFF) {
+		clear_port_status_change_nl(port, HUB_STATUS_C_PORT_CONNECTION);
+		clear_port_status_change_nl(port, HUB_STATUS_C_PORT_ENABLE);
+		clear_port_status_change_nl(port, HUB_STATUS_C_PORT_RESET);
+	}
+	if (state == HUB_PORT_STATE_RESUMING) {
+		set_port_state_delayed(port, 10*1000,
+		    HUB_PORT_STATE_RESUMING, HUB_PORT_STATE_ENABLED);
+	}
+	if (state == HUB_PORT_STATE_RESETTING) {
+		set_port_state_delayed(port, 10*1000,
+		    HUB_PORT_STATE_RESETTING, HUB_PORT_STATE_ENABLED);
+	}
+	if ((port->state == HUB_PORT_STATE_RESETTING)
+	    && (state == HUB_PORT_STATE_ENABLED)) {
+		set_port_status_change_nl(port, HUB_STATUS_C_PORT_RESET);
+	}
+	
 	port->state = state;
-	if (state == HUB_PORT_STATE_POWERED_OFF) {
-		clear_port_status_change(port, HUB_STATUS_C_PORT_CONNECTION);
-		clear_port_status_change(port, HUB_STATUS_C_PORT_ENABLE);
-		clear_port_status_change(port, HUB_STATUS_C_PORT_RESET);
-	}
-	if (state == HUB_PORT_STATE_RESUMING) {
-		async_usleep(10*1000);
-		if (port->state == state) {
-			set_port_state(port, HUB_PORT_STATE_ENABLED);
-		}
-	}
-	if (state == HUB_PORT_STATE_RESETTING) {
-		async_usleep(10*1000);
-		if (port->state == state) {
-			set_port_status_change(port, HUB_STATUS_C_PORT_RESET);
-			set_port_state(port, HUB_PORT_STATE_ENABLED);
-		}
-	}
 }
 
@@ -122,5 +201,5 @@
 		} \
 	} while (false); \
-	hub_port_t *portvar = &hub_dev.ports[index]
+	hub_port_t *portvar = &hub_dev.ports[index-1]
 
 
@@ -134,53 +213,80 @@
 	_GET_PORT(port, portindex);
 	
+	fibril_mutex_lock(&port->guard);
+	int rc = ENOTSUP;
+
 	switch (feature) {
 		case USB_HUB_FEATURE_PORT_ENABLE:
 			if ((port->state != HUB_PORT_STATE_NOT_CONFIGURED)
 			    && (port->state != HUB_PORT_STATE_POWERED_OFF)) {
-				set_port_state(port, HUB_PORT_STATE_DISABLED);
-			}
-			return EOK;
+				set_port_state_nl(port, HUB_PORT_STATE_DISABLED);
+			}
+			rc = EOK;
+			break;
 		
 		case USB_HUB_FEATURE_PORT_SUSPEND:
 			if (port->state != HUB_PORT_STATE_SUSPENDED) {
-				return EOK;
-			}
-			set_port_state(port, HUB_PORT_STATE_RESUMING);
-			return EOK;
+				rc = EOK;
+				break;
+			}
+			set_port_state_nl(port, HUB_PORT_STATE_RESUMING);
+			rc = EOK;
+			break;
 			
 		case USB_HUB_FEATURE_PORT_POWER:
 			if (port->state != HUB_PORT_STATE_NOT_CONFIGURED) {
-				set_port_state(port, HUB_PORT_STATE_POWERED_OFF);
-			}
-			return EOK;
+				set_port_state_nl(port, HUB_PORT_STATE_POWERED_OFF);
+			}
+			rc = EOK;
+			break;
 		
 		case USB_HUB_FEATURE_C_PORT_CONNECTION:
-			clear_port_status_change(port, HUB_STATUS_C_PORT_CONNECTION);
-			return EOK;
+			clear_port_status_change_nl(port, HUB_STATUS_C_PORT_CONNECTION);
+			rc = EOK;
+			break;
 		
 		case USB_HUB_FEATURE_C_PORT_ENABLE:
-			clear_port_status_change(port, HUB_STATUS_C_PORT_ENABLE);
-			return EOK;
+			clear_port_status_change_nl(port, HUB_STATUS_C_PORT_ENABLE);
+			rc = EOK;
+			break;
 		
 		case USB_HUB_FEATURE_C_PORT_SUSPEND:
-			clear_port_status_change(port, HUB_STATUS_C_PORT_SUSPEND);
-			return EOK;
+			clear_port_status_change_nl(port, HUB_STATUS_C_PORT_SUSPEND);
+			rc = EOK;
+			break;
 			
 		case USB_HUB_FEATURE_C_PORT_OVER_CURRENT:
-			clear_port_status_change(port, HUB_STATUS_C_PORT_OVER_CURRENT);
-			return EOK;
-	}
-	
+			clear_port_status_change_nl(port, HUB_STATUS_C_PORT_OVER_CURRENT);
+			rc = EOK;
+			break;
+
+		case USB_HUB_FEATURE_C_PORT_RESET:
+			clear_port_status_change_nl(port, HUB_STATUS_C_PORT_RESET);
+			rc = EOK;
+			break;
+	}
+	
+	fibril_mutex_unlock(&port->guard);
+
+	return rc;
+}
+
+static int get_bus_state(uint16_t portindex)
+{
 	return ENOTSUP;
 }
 
-static int get_bus_state(uint16_t portindex)
-{
-	return ENOTSUP;
-}
-
-static int get_hub_descriptor(uint8_t descriptor_type,
-    uint8_t descriptor_index, uint16_t length)
-{
+static int get_hub_descriptor(struct usbvirt_device *dev,
+    uint8_t descriptor_index,
+    uint8_t descriptor_type, uint16_t length)
+{
+	if (descriptor_type == USB_DESCTYPE_HUB) {
+		int rc = dev->control_transfer_reply(dev, 0,
+		    &hub_descriptor, hub_descriptor.length);
+
+		return rc;
+
+	}
+
 	return ENOTSUP;
 }
@@ -198,4 +304,6 @@
 	_GET_PORT(port, portindex);
 	
+	fibril_mutex_lock(&port->guard);
+
 	uint32_t status;
 	status = MAKE_BYTE(
@@ -225,4 +333,8 @@
 	status |= (port->status_change << 16);
 	
+	fibril_mutex_unlock(&port->guard);
+
+	dprintf(2, "GetPortStatus(port=%d, status=%u)\n", (int)portindex,
+	    (unsigned int) status);
 	return virthub_dev.control_transfer_reply(&virthub_dev, 0, &status, 4);
 }
@@ -238,24 +350,33 @@
 	_GET_PORT(port, portindex);
 	
+	fibril_mutex_lock(&port->guard);
+
+	int rc = ENOTSUP;
+
 	switch (feature) {
 		case USB_HUB_FEATURE_PORT_RESET:
 			if (port->state != HUB_PORT_STATE_POWERED_OFF) {
-				set_port_state(port, HUB_PORT_STATE_RESETTING);
-			}
-			return EOK;
+				set_port_state_nl(port, HUB_PORT_STATE_RESETTING);
+			}
+			rc = EOK;
+			break;
 		
 		case USB_HUB_FEATURE_PORT_SUSPEND:
 			if (port->state == HUB_PORT_STATE_ENABLED) {
-				set_port_state(port, HUB_PORT_STATE_SUSPENDED);
-			}
-			return EOK;
+				set_port_state_nl(port, HUB_PORT_STATE_SUSPENDED);
+			}
+			rc = EOK;
+			break;
 		
 		case USB_HUB_FEATURE_PORT_POWER:
 			if (port->state == HUB_PORT_STATE_POWERED_OFF) {
-				set_port_state(port, HUB_PORT_STATE_DISCONNECTED);
-			}
-			return EOK;
-	}
-	return ENOTSUP;
+				set_port_state_nl(port, HUB_PORT_STATE_DISCONNECTED);
+			}
+			rc = EOK;
+			break;
+	}
+
+	fibril_mutex_unlock(&port->guard);
+	return rc;
 }
 
@@ -267,5 +388,5 @@
     usb_device_request_setup_packet_t *request, uint8_t *data)
 {	
-	dprintf(2, "hub class request (%d)\n", (int) request->request);
+	dprintf(2, "hub class request (%d)", (int) request->request);
 	
 	uint8_t recipient = request->request_type & 31;
@@ -298,5 +419,5 @@
 			
 		case USB_HUB_REQUEST_GET_DESCRIPTOR:
-			return get_hub_descriptor(request->value_low,
+			return get_hub_descriptor(dev, request->value_low,
 			    request->value_high, request->length);
 			
@@ -316,4 +437,6 @@
 			
 		default:
+			dprintf(0, "WARN: unknown request (%d)!\n",
+			    request->request);
 			break;
 	}
@@ -325,12 +448,31 @@
 }
 
+void clear_port_status_change_nl(hub_port_t *port, uint16_t change)
+{
+	port->status_change &= (~change);
+	dprintf(2, "cleared port %d status change %d (%u)", port->index,
+	    (int)change, (unsigned int) port->status_change);
+}
+
+void set_port_status_change_nl(hub_port_t *port, uint16_t change)
+{
+	port->status_change |= change;
+	dprintf(2, "set port %d status change %d (%u)", port->index,
+	    (int)change, (unsigned int) port->status_change);
+
+}
+
 void clear_port_status_change(hub_port_t *port, uint16_t change)
 {
-	port->status_change &= (~change);
+	fibril_mutex_lock(&port->guard);
+	clear_port_status_change_nl(port, change);
+	fibril_mutex_unlock(&port->guard);
 }
 
 void set_port_status_change(hub_port_t *port, uint16_t change)
 {
-	port->status_change |= change;
+	fibril_mutex_lock(&port->guard);
+	set_port_status_change_nl(port, change);
+	fibril_mutex_unlock(&port->guard);
 }
 
@@ -350,7 +492,9 @@
 		hub_port_t *port = &hub_dev.ports[i];
 		
+		fibril_mutex_lock(&port->guard);
 		if (port->status_change != 0) {
 			change_map |= (1 << (i + 1));
 		}
+		fibril_mutex_unlock(&port->guard);
 	}
 	
Index: uspace/drv/vhc/vhcd.h
===================================================================
--- uspace/drv/vhc/vhcd.h	(revision 84439d7c2ebefbea307e636b8e8316fb8f84e090)
+++ uspace/drv/vhc/vhcd.h	(revision 75732daeac84e2935c03d316ed5cb327455ac6a3)
@@ -36,4 +36,6 @@
 #define VHCD_VHCD_H_
 
+#include <usb/debug.h>
+
 #define NAME "vhc"
 #define NAME_DEV "hcd-virt-dev"
@@ -43,6 +45,6 @@
 #define DEVMAP_PATH_DEV NAMESPACE "/" NAME_DEV
 
-extern int debug_level;
-void dprintf(int, const char *, ...);
+#define dprintf(level, format, ...) \
+	usb_dprintf(NAME, (level), format "\n", ##__VA_ARGS__)
 void dprintf_inval_call(int, ipc_call_t, ipcarg_t);
 
